# Step 1: Load Your Data
setwd("~/Desktop/Lectures/2023-2024/Statistical Tools/R practice")
data <- read.csv("daily_csv.csv")


# Step 2: View Data
head(data)
# Check if there is any missing data
missing_values_count <- sum(is.na(data$Price))
data<-na.omit(data)

# Step 3: Measures of Central Tendency

#Arithmetic Mean
M_a<-function(x){
n<-length(x)
res<-sum(x)/n
return(res)
}
mean(data$Price, na.rm = TRUE)
M_a(data$Price)

#Geometric Mean
library(DescTools)
M_g1<-function(x){
  n<-length(x)
res<-(prod(x))^(1/n)
return(res)
}
M_g1(data$Price)

#Too many observations? 
y<-data$Price[1:100] #Take a subsample of x
M_g1(y)
#So, what to do? Just use Maths!
M_g2<-function(x){
  res<-exp(mean(log(x)))
  return(res)
}
M_g2(y)

M_g2(data$Price)

# Median

median_value <- median(data$Price)

# Mode

density_estimation <- density(data$Price)
mode<-density_estimation$x[which.max(density_estimation$y)]


tab<-c(mean(data$Price), median(data$Price),mode)
names(tab)<-c("mean", "median", "mode")

# Step 4: Measures of Dispersion
data_range <-max(data$Price)-min(data$Price)
data_range <- range(data$Price)


variance_value <- var(data$Price)

variance<-function(x){
  n<-length(x)
  mu<-sum(x)/n
  return(sum((x-mu)^2)/n)
}
variance(data$Price)

sd_value <- sd(data$Price)
sqrt(variance(data$Price))

# Step 5: Data Visualization (Histogram)
install.packages("ggplot2")
library(ggplot2)
ggplot(data, aes(x = Price)) +
  geom_histogram()

par(mar=c(1,1,1,1))
hist(data$Price, freq = FALSE)

# Step 6: Summary Statistics
summary(data)




